//SETA43 09/02/2016
// xsetaseta@gmail.com
// BMP180->lcdNOKIA
//Arduino Version 1.0.1
//Debian 7
//Version de libreria propia

#include <Wire.h>

#define BMP180_ADDR 0x77 // 7-bit address

#define	BMP180_REG_CONTROL 0xF4
#define	BMP180_REG_RESULT 0xF6
#define	BMP180_COMMAND_TEMPERATURE 0x2E

int AC1,AC2,AC3,VB1,VB2,MB,MC,MD;
unsigned int AC4,AC5,AC6; 
unsigned char _error;

long Temperatura,Presion,PresionBase;
unsigned char mibufferU[10];
char mibuffer[20];


// altura en Palencia
#define ALTURA 790


void setup()
{
  LcdInitialise();
  LcdClear();
  drawBox(); 
  gotoXY(1,0); LcdString("BMP180_v2");  
  Serial.begin(9600);  // start serial for output
  startBMP180();
  getBMP180();
  PresionBase=Presion;   
  Serial.print("Presion base: ");
  Serial.print(PresionBase);
  Serial.println(" mb");  
}

void loop()
{
  int z;
  long zu;
  //double a,P;

  if(getBMP180()){  Serial.print("ERRORES=");  Serial.println(_error);}
   
  //dtostrf(zf,5, 2, mibuffer); 
  gotoXY(1,2); LcdString("T:");  intTOstring(Temperatura,5,2);  LcdString( mibuffer); LcdString(" C");
  Serial.print(mibuffer);  Serial.println(" C");
  
  z=Presion/100;
  zu=Presion;
   //dtostrf(zf,5, 0, mibuffer); 
  gotoXY(1,1); LcdString("P:");  intTOstring(z,5,0);  LcdString( mibuffer); LcdString(" mb");
  Serial.print(mibuffer);  Serial.println(" mb");
 
   z=DifAltitud(Presion,PresionBase);
  //dtostrf(a,5, 1, mibuffer);
  gotoXY(1,3); LcdString("DA:"); intTOstring(z,5,2); LcdString( mibuffer);LcdString("m");
 Serial.print(mibuffer);  Serial.print(" metros\n");
 
  delay(2000);
}



int DifAltitud(long Pres,long PresBase)
{
 long z,zz;
   
   z=PresBase-Pres;
   z*=904;
   z/=100;     
   return((int)z);  
}

/*
double altitude(double P, double P0)

{
	return(44330.0*(1-pow(P/P0,1/5.255)));
}
*/


//_SETA43_____

int MiLecturaI(char address)
{
  char x;
  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(address);
  if(Wire.endTransmission()) Serial.print("ERROR ");
  
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++)  mibufferU[x] = Wire.read();
  return( (((int)mibufferU[0]<<8)|(int)mibufferU[1]) );
  
}  


char startBMP180(void)
{
  Wire.begin();      
  AC1=MiLecturaI(0xAA);
  AC2=MiLecturaI(0xAC);
  AC3=MiLecturaI(0xAE);
  AC4=MiLecturaI(0xb0);
  AC5=MiLecturaI(0xb2);
  AC6=MiLecturaI(0xb4);
  VB1=MiLecturaI(0xb6);
  VB2=MiLecturaI(0xb8);
  MB=MiLecturaI(0xba);
  MC=MiLecturaI(0xbc);
  MD=MiLecturaI(0xbe);
 
}

char getBMP180(void)
{
  char x;
  long x1,x2,x3,mtu,mpu,b5,b6,b3,p;
  unsigned long b4,b7;
  
  _error=0;
  
  
  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = BMP180_COMMAND_TEMPERATURE;  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(20);
  
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++) mibufferU[x] = Wire.read();
  mtu = mibufferU[0];
  mtu=mtu<<8;
  mtu+=mibufferU[1];  //UT
 Serial.print("mtu=");Serial.println(mtu);


  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = 0x34;  //oss=0
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(26);
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,3);
  while(Wire.available() != 3) ; 
  for(x=0;x<3;x++) mibufferU[x] = Wire.read();  
 // for(x=0;x<3;x++) Serial.println(mibufferU[x]);  
  mpu = mibufferU[0];
  mpu=mpu<<16;
  x1=mibufferU[1];
  x1=x1<<8;
  mpu+=x1;
  mpu+=mibufferU[1];
  mpu=mpu>>8;  //oss=0    UP
  Serial.print("mpu=");Serial.println(mpu);
     
  x1=mtu-AC6;  x1*=AC5;  x1=x1>>15;
  x2=MC;  x2=x2<<11;  x2/=(x1+MD);
  x1+=x2;
  b5=x1;
  x1+=8;
  x1*=10;
  Temperatura=x1>>4;
  

  b6=b5-4000;
  x1=b6*b6;  x1=x1>>12;  x1=x1*VB2;  x1=x1>>11;
  x2=AC2;  x2=x2*b6; x2=x2>>11;
  x3=x2+x1;
  b3=AC1; b3=b3<<2; b3=b3+x3; b3=b3+2; b3=b3>>2;
  x1=AC3; x1*=b6;  x1=x1>>13;
  x2=b6*b6; x2=x2>>12; x2=x2*VB1; x2=x2>>16;
  x3=x1+x2;  x3=x3+2; x3=x3>>2;
  b4=x3;  b4=b4+32768;  b4=b4*AC4;  b4=b4>>15;
  b7=mpu-b3;  b7=b7*50000;
  if(b7<0x80000000)
    {
      p=b7; p=p<<1; p=p/b4;
    }
    else
    {
      p=b7/b4;  p=p<<1;
    }
  x1=p;  x1=x1>>8;  x1=x1*x1;
  x1=x1*3038;  x1=x1>>16;
  x2=-7357;  x2*=p;  x2=x2>>16;
  x1+=x2;  x1=x1+3791; x1=x1>>4;  p+=x1; 
  Presion=p;
  
return(_error);
  	
}


//_SETA43__
void intTOstring(int n,unsigned char dig,unsigned char dec)
{
	int z,x,zz;
	char signo;

	zz=0;
	z=10000;
	if(n<0)	{ signo='-'; n*=-1;}	else	{signo='+';	}
	mibuffer[zz]=signo;	zz++;
	for(;z>0;z=z/10)
	{
		x=n/z;
		n=n-(z*x);
		mibuffer[zz]=x+'0';
		zz++;
	}
	mibuffer[zz]=0;
	
	if(dec!=0)
	 {
		x=zz+1;
		for(;zz>=0;zz--)
		{
		mibuffer[x]=mibuffer[zz];
		x--;
		if(0==dec) { mibuffer[x]='.'; x--;}	
		dec--;
		}
	 }

}


//_____LCD NOKIA_______-


// The pins to use on the arduino
#define PIN_SCE   3
#define PIN_RESET 4
#define PIN_DC    5
#define PIN_SDIN  6
#define PIN_SCLK  7 

// COnfiguration for the LCD
#define LCD_C     LOW
#define LCD_D     HIGH
#define LCD_CMD   0

// Size of the LCD
#define LCD_X     84
#define LCD_Y     48

int scrollPosition = -10;

static const byte ASCII[][5] =
{
 {0x00, 0x00, 0x00, 0x00, 0x00} // 20
,{0x00, 0x00, 0x5f, 0x00, 0x00} // 21 !
,{0x00, 0x07, 0x00, 0x07, 0x00} // 22 "
,{0x14, 0x7f, 0x14, 0x7f, 0x14} // 23 #
,{0x24, 0x2a, 0x7f, 0x2a, 0x12} // 24 $
,{0x23, 0x13, 0x08, 0x64, 0x62} // 25 %
,{0x36, 0x49, 0x55, 0x22, 0x50} // 26 &
,{0x00, 0x05, 0x03, 0x00, 0x00} // 27 '
,{0x00, 0x1c, 0x22, 0x41, 0x00} // 28 (
,{0x00, 0x41, 0x22, 0x1c, 0x00} // 29 )
,{0x14, 0x08, 0x3e, 0x08, 0x14} // 2a *
,{0x08, 0x08, 0x3e, 0x08, 0x08} // 2b +
,{0x00, 0x50, 0x30, 0x00, 0x00} // 2c ,
,{0x08, 0x08, 0x08, 0x08, 0x08} // 2d -
,{0x00, 0x60, 0x60, 0x00, 0x00} // 2e .
,{0x20, 0x10, 0x08, 0x04, 0x02} // 2f /
,{0x3e, 0x51, 0x49, 0x45, 0x3e} // 30 0
,{0x00, 0x42, 0x7f, 0x40, 0x00} // 31 1
,{0x42, 0x61, 0x51, 0x49, 0x46} // 32 2
,{0x21, 0x41, 0x45, 0x4b, 0x31} // 33 3
,{0x18, 0x14, 0x12, 0x7f, 0x10} // 34 4
,{0x27, 0x45, 0x45, 0x45, 0x39} // 35 5
,{0x3c, 0x4a, 0x49, 0x49, 0x30} // 36 6
,{0x01, 0x71, 0x09, 0x05, 0x03} // 37 7
,{0x36, 0x49, 0x49, 0x49, 0x36} // 38 8
,{0x06, 0x49, 0x49, 0x29, 0x1e} // 39 9
,{0x00, 0x36, 0x36, 0x00, 0x00} // 3a :
,{0x00, 0x56, 0x36, 0x00, 0x00} // 3b ;
,{0x08, 0x14, 0x22, 0x41, 0x00} // 3c <
,{0x14, 0x14, 0x14, 0x14, 0x14} // 3d =
,{0x00, 0x41, 0x22, 0x14, 0x08} // 3e >
,{0x02, 0x01, 0x51, 0x09, 0x06} // 3f ?
,{0x32, 0x49, 0x79, 0x41, 0x3e} // 40 @
,{0x7e, 0x11, 0x11, 0x11, 0x7e} // 41 A
,{0x7f, 0x49, 0x49, 0x49, 0x36} // 42 B
,{0x3e, 0x41, 0x41, 0x41, 0x22} // 43 C
,{0x7f, 0x41, 0x41, 0x22, 0x1c} // 44 D
,{0x7f, 0x49, 0x49, 0x49, 0x41} // 45 E
,{0x7f, 0x09, 0x09, 0x09, 0x01} // 46 F
,{0x3e, 0x41, 0x49, 0x49, 0x7a} // 47 G
,{0x7f, 0x08, 0x08, 0x08, 0x7f} // 48 H
,{0x00, 0x41, 0x7f, 0x41, 0x00} // 49 I
,{0x20, 0x40, 0x41, 0x3f, 0x01} // 4a J
,{0x7f, 0x08, 0x14, 0x22, 0x41} // 4b K
,{0x7f, 0x40, 0x40, 0x40, 0x40} // 4c L
,{0x7f, 0x02, 0x0c, 0x02, 0x7f} // 4d M
,{0x7f, 0x04, 0x08, 0x10, 0x7f} // 4e N
,{0x3e, 0x41, 0x41, 0x41, 0x3e} // 4f O
,{0x7f, 0x09, 0x09, 0x09, 0x06} // 50 P
,{0x3e, 0x41, 0x51, 0x21, 0x5e} // 51 Q
,{0x7f, 0x09, 0x19, 0x29, 0x46} // 52 R
,{0x46, 0x49, 0x49, 0x49, 0x31} // 53 S
,{0x01, 0x01, 0x7f, 0x01, 0x01} // 54 T
,{0x3f, 0x40, 0x40, 0x40, 0x3f} // 55 U
,{0x1f, 0x20, 0x40, 0x20, 0x1f} // 56 V
,{0x3f, 0x40, 0x38, 0x40, 0x3f} // 57 W
,{0x63, 0x14, 0x08, 0x14, 0x63} // 58 X
,{0x07, 0x08, 0x70, 0x08, 0x07} // 59 Y
,{0x61, 0x51, 0x49, 0x45, 0x43} // 5a Z
,{0x00, 0x7f, 0x41, 0x41, 0x00} // 5b [
,{0x02, 0x04, 0x08, 0x10, 0x20} // 5c ÃÂ¥
,{0x00, 0x41, 0x41, 0x7f, 0x00} // 5d ]
,{0x04, 0x02, 0x01, 0x02, 0x04} // 5e ^
,{0x40, 0x40, 0x40, 0x40, 0x40} // 5f _
,{0x00, 0x01, 0x02, 0x04, 0x00} // 60 `
,{0x20, 0x54, 0x54, 0x54, 0x78} // 61 a
,{0x7f, 0x48, 0x44, 0x44, 0x38} // 62 b
,{0x38, 0x44, 0x44, 0x44, 0x20} // 63 c
,{0x38, 0x44, 0x44, 0x48, 0x7f} // 64 d
,{0x38, 0x54, 0x54, 0x54, 0x18} // 65 e
,{0x08, 0x7e, 0x09, 0x01, 0x02} // 66 f
,{0x0c, 0x52, 0x52, 0x52, 0x3e} // 67 g
,{0x7f, 0x08, 0x04, 0x04, 0x78} // 68 h
,{0x00, 0x44, 0x7d, 0x40, 0x00} // 69 i
,{0x20, 0x40, 0x44, 0x3d, 0x00} // 6a j
,{0x7f, 0x10, 0x28, 0x44, 0x00} // 6b k
,{0x00, 0x41, 0x7f, 0x40, 0x00} // 6c l
,{0x7c, 0x04, 0x18, 0x04, 0x78} // 6d m
,{0x7c, 0x08, 0x04, 0x04, 0x78} // 6e n
,{0x38, 0x44, 0x44, 0x44, 0x38} // 6f o
,{0x7c, 0x14, 0x14, 0x14, 0x08} // 70 p
,{0x08, 0x14, 0x14, 0x18, 0x7c} // 71 q
,{0x7c, 0x08, 0x04, 0x04, 0x08} // 72 r
,{0x48, 0x54, 0x54, 0x54, 0x20} // 73 s
,{0x04, 0x3f, 0x44, 0x40, 0x20} // 74 t
,{0x3c, 0x40, 0x40, 0x20, 0x7c} // 75 u
,{0x1c, 0x20, 0x40, 0x20, 0x1c} // 76 v
,{0x3c, 0x40, 0x30, 0x40, 0x3c} // 77 w
,{0x44, 0x28, 0x10, 0x28, 0x44} // 78 x
,{0x0c, 0x50, 0x50, 0x50, 0x3c} // 79 y
,{0x44, 0x64, 0x54, 0x4c, 0x44} // 7a z
,{0x00, 0x08, 0x36, 0x41, 0x00} // 7b {
,{0x00, 0x00, 0x7f, 0x00, 0x00} // 7c |
,{0x00, 0x41, 0x36, 0x08, 0x00} // 7d }
,{0x10, 0x08, 0x08, 0x10, 0x08} // 7e 
//,{0x00, 0x06, 0x09, 0x09, 0x06} // 7f 
,{B11111111, B01111110, B00011000, B01111110, B11111111} //Stereo 127
};



void LcdCharacter(char character)
{
  unsigned char z,z1;
  if(character==0) return;
  z1=character - 0x20;
  LcdWrite(LCD_D, 0x00);
  for (int index = 0; index < 5; index++)
  {
    //para que funciona en proteus
    
    z=ASCII[z1][index];
    LcdWrite(LCD_D, z);
   // LcdWrite(LCD_D, ASCII[character - 0x20][index]);    
 }
 LcdWrite(LCD_D, 0x00);
}

void LcdCharacterX(char character)
{
  unsigned char z,z1;
  z1=character - 0x20;       
  LcdWrite(LCD_D, 0x00);
  for (int index = 0; index < 5; index++)
  {
     //para que funciona en proteus
     z=ASCII[z1][index];
     LcdWrite(LCD_D, z);
     LcdWrite(LCD_D, z);
    //LcdWrite(LCD_D, ASCII[character - 0x20][index]);
    //LcdWrite(LCD_D, ASCII[character - 0x20][index]);
  }
  LcdWrite(LCD_D, 0x00);
}  

void LcdClear(void)
{
  for (int index = 0; index < LCD_X * LCD_Y / 8; index++)
  {
    LcdWrite(LCD_D, 0x00);
  }
}

void LcdInitialise(void)
{
  pinMode(PIN_SCE,   OUTPUT);
  pinMode(PIN_RESET, OUTPUT);
  pinMode(PIN_DC,    OUTPUT);
  pinMode(PIN_SDIN,  OUTPUT);
  pinMode(PIN_SCLK,  OUTPUT);
  
  digitalWrite(PIN_RESET, LOW);
  digitalWrite(PIN_RESET, HIGH);
  
  LcdWrite(LCD_CMD, 0x21);  // LCD Extended Commands.
  LcdWrite(LCD_CMD, 0xBf);  // Set LCD Vop (Contrast). //B1
  LcdWrite(LCD_CMD, 0x04);  // Set Temp coefficent. //0x04
  LcdWrite(LCD_CMD, 0x14);  // LCD bias mode 1:48. //0x13
  LcdWrite(LCD_CMD, 0x0C);  // LCD in normal mode. 0x0d for inverse
  LcdWrite(LCD_C, 0x20);
  LcdWrite(LCD_C, 0x0C);
}

void LcdString(char *characters)
{
  while (*characters)
  {
    LcdCharacter(*characters++);
  }
}
void LcdStringX(char *characters)
{
  while (*characters)
  {
    LcdCharacterX(*characters++);
  }
} 

void LcdWrite(byte dc, byte data)
{
  digitalWrite(PIN_DC, dc);
  digitalWrite(PIN_SCE, LOW);
  shiftOut(PIN_SDIN, PIN_SCLK, MSBFIRST, data);
  digitalWrite(PIN_SCE, HIGH);
}

/**
 * gotoXY routine to position cursor
 * x - range: 0 to 84
 * y - range: 0 to 5
 */
 void gotoXY(int x, int y)
 {
  LcdWrite( 0, 0x80 | x);  // Column.
  LcdWrite( 0, 0x40 | y);  // Row.
}

void drawBox(void)
{
  int j;
  for(j = 0; j < 84; j++) // top
  {
    gotoXY(j, 0);
    LcdWrite(1, 0x01);
  }     
  
  for(j = 0; j < 84; j++) //Bottom
  {
    gotoXY(j, 5);
    LcdWrite(1, 0x80);
  }     
  
  for(j = 0; j < 6; j++) // Right
  {
    gotoXY(83, j);
    LcdWrite(1, 0xff);
  }     
  
  for(j = 0; j < 6; j++) // Left
  {
    gotoXY(0, j);
    LcdWrite(1, 0xff);
  }
}

void Scroll(String message)
{
  for (int i = scrollPosition; i < scrollPosition + 11; i++)
  {
    if ((i >= message.length()) || (i < 0))
    {
      LcdCharacter(' ');
    }
    else	
    {
      LcdCharacter(message.charAt(i));
    }
  }
  scrollPosition++;
  if ((scrollPosition >= message.length()) && (scrollPosition > 0))
  {
    scrollPosition = -10;
  }
}



